window.Gleam.initSearch([{"doc":"startest","title":"startest","content":"# startest\n\n[![Package Version](https://img.shields.io/hexpm/v/startest)](https://hex.pm/packages/startest)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/startest/)\n\n🌠 A testing framework to help you shoot for the stars.\n\n## Installation\n\n```sh\ngleam add --dev startest\n```\n\n```gleam\nimport startest.{describe, it}\nimport startest/expect\nimport startest/reporters/default as default_reporter\n\npub fn main() {\n  let reporters = [default_reporter.new()]\n\n  [\n    describe(&quot;My Project&quot;, [\n      describe(&quot;2 + 2&quot;, [\n        it(&quot;equals 4&quot;, fn() {\n          2 + 2\n          |&gt; expect.to_equal(4)\n        }),\n      ]),\n    ]),\n  ]\n  |&gt; startest.run_tests(reporters)\n}\n```\n\n## Targets\n\n`startest` supports both targets: Erlang and JavaScript.\n","url":"index.html"},{"doc":"startest/assertion_error","title":"AssertionError","content":"pub type AssertionError {\n  AssertionError(\n    message: String,\n    actual: String,\n    expected: String,\n  )\n}\n\nAssertionError(message: String, actual: String, expected: String)\n\n\nSynonyms:\nstartest/assertion_error.AssertionError\nstartest/assertion_error AssertionError","url":"startest/assertion_error.html#AssertionError"},{"doc":"startest/assertion_error","title":"RescuedAssertionError","content":"pub type RescuedAssertionError {\n  RescuedAssertionError(message: String)\n}\n\nRescuedAssertionError(message: String)\n\n\nSynonyms:\nstartest/assertion_error.RescuedAssertionError\nstartest/assertion_error RescuedAssertionError","url":"startest/assertion_error.html#RescuedAssertionError"},{"doc":"startest/assertion_error","title":"raise","content":"pub fn raise(error: AssertionError) -&gt; a\n Raises an `AssertionError`.\n\n Intended for use by matchers to cause a test to fail.\nSynonyms:\nstartest/assertion_error.raise\nstartest/assertion_error raise","url":"startest/assertion_error.html#raise"},{"doc":"startest/assertion_error","title":"startest/assertion_error","content":"","url":"startest/assertion_error.html"},{"doc":"startest/test_failure","title":"TestFailure","content":"pub type TestFailure {\n  AssertionError(RescuedAssertionError)\n  GenericError(Exception)\n}\n\nAssertionError(RescuedAssertionError)\n\n\nGenericError(Exception)\n\n\nSynonyms:\nstartest/test_failure.TestFailure\nstartest/test_failure TestFailure","url":"startest/test_failure.html#TestFailure"},{"doc":"startest/test_failure","title":"rescue","content":"pub fn rescue(f: fn() -&gt; Nil) -&gt; Result(Nil, TestFailure)\n\nSynonyms:\nstartest/test_failure.rescue\nstartest/test_failure rescue","url":"startest/test_failure.html#rescue"},{"doc":"startest/test_failure","title":"to_string","content":"pub fn to_string(failure: TestFailure) -&gt; String\n\nSynonyms:\nstartest/test_failure.to_string\nstartest/test_failure to_string","url":"startest/test_failure.html#to_string"},{"doc":"startest/test_failure","title":"startest/test_failure","content":"","url":"startest/test_failure.html"},{"doc":"startest/test_case","title":"ExecutedTest","content":"pub type ExecutedTest {\n  ExecutedTest(test_case: Test, outcome: TestOutcome)\n}\n A `Test` that has been executed and has a `TestOutcome`.\nExecutedTest(test_case: Test, outcome: TestOutcome)\n\n\nSynonyms:\nstartest/test_case.ExecutedTest\nstartest/test_case ExecutedTest","url":"startest/test_case.html#ExecutedTest"},{"doc":"startest/test_case","title":"Test","content":"pub type Test {\n  Test(name: String, body: fn() -&gt; Nil, skipped: Bool)\n}\n A test case.\nTest(name: String, body: fn() -&gt; Nil, skipped: Bool)\n\n\nSynonyms:\nstartest/test_case.Test\nstartest/test_case Test","url":"startest/test_case.html#Test"},{"doc":"startest/test_case","title":"TestOutcome","content":"pub type TestOutcome {\n  Passed\n  Failed(TestFailure)\n  Skipped\n}\n The outcome of a `Test` that has been run.\nPassed\n\n\nFailed(TestFailure)\n\n\nSkipped\n\n\nSynonyms:\nstartest/test_case.TestOutcome\nstartest/test_case TestOutcome","url":"startest/test_case.html#TestOutcome"},{"doc":"startest/test_case","title":"is_failed","content":"pub fn is_failed(executed_test: ExecutedTest) -&gt; Bool\n\nSynonyms:\nstartest/test_case.is_failed\nstartest/test_case is_failed","url":"startest/test_case.html#is_failed"},{"doc":"startest/test_case","title":"startest/test_case","content":"","url":"startest/test_case.html"},{"doc":"startest/reporter","title":"Reporter","content":"pub type Reporter {\n  Reporter(report: fn(ExecutedTest) -&gt; Nil)\n}\n\nReporter(report: fn(ExecutedTest) -&gt; Nil)\n\n\nSynonyms:\nstartest/reporter.Reporter\nstartest/reporter Reporter","url":"startest/reporter.html#Reporter"},{"doc":"startest/reporter","title":"startest/reporter","content":"","url":"startest/reporter.html"},{"doc":"startest/test_tree","title":"TestTree","content":"pub type TestTree {\n  Suite(name: String, suite: List(TestTree))\n  Test(Test)\n}\n\nSuite(name: String, suite: List(TestTree))\n\n\nTest(Test)\n\n\nSynonyms:\nstartest/test_tree.TestTree\nstartest/test_tree TestTree","url":"startest/test_tree.html#TestTree"},{"doc":"startest/test_tree","title":"all_tests","content":"pub fn all_tests(tree: TestTree) -&gt; List(#(String, Test))\n\nSynonyms:\nstartest/test_tree.all_tests\nstartest/test_tree all_tests","url":"startest/test_tree.html#all_tests"},{"doc":"startest/test_tree","title":"startest/test_tree","content":"","url":"startest/test_tree.html"},{"doc":"startest/runner","title":"run_tests","content":"pub fn run_tests(\n  tests: List(TestTree),\n  reporters: List(Reporter),\n) -&gt; Nil\n\nSynonyms:\nstartest/runner.run_tests\nstartest/runner run_tests","url":"startest/runner.html#run_tests"},{"doc":"startest/runner","title":"startest/runner","content":"","url":"startest/runner.html"},{"doc":"startest","title":"describe","content":"pub fn describe(name: String, suite: List(TestTree)) -&gt; TestTree\n Defines a new test suite with the given name.\n\n A suite is a way of grouping related tests together.\n\n `describe`s may also be nested in other `describe`s to form a hierarchy of tests.\nSynonyms:\nstartest.describe\nstartest describe","url":"startest.html#describe"},{"doc":"startest","title":"it","content":"pub fn it(name: String, body: fn() -&gt; Nil) -&gt; TestTree\n Defines a test with the given name.\nSynonyms:\nstartest.it\nstartest it","url":"startest.html#it"},{"doc":"startest","title":"run_tests","content":"pub fn run_tests(\n  tests: List(TestTree),\n  reporters: List(Reporter),\n) -&gt; Nil\n Runs the given tests and reports results using the provided list of `Reporter`s.\nSynonyms:\nstartest.run_tests\nstartest run_tests","url":"startest.html#run_tests"},{"doc":"startest","title":"xit","content":"pub fn xit(name: String, body: fn() -&gt; Nil) -&gt; TestTree\n Skips a test defined using `it`.\n\n This can be used to skip running certain tests, but without deleting the code.\n For instance, you might want to do this if a test is flaky and you want to stop\n running it temporarily until it can be fixed.\nSynonyms:\nstartest.xit\nstartest xit","url":"startest.html#xit"},{"doc":"startest","title":"startest","content":"","url":"startest.html"},{"doc":"startest/expect","title":"to_be_error","content":"pub fn to_be_error(actual: Result(a, b)) -&gt; b\n Asserts that the given value is `Error(_)`.\nSynonyms:\nstartest/expect.to_be_error\nstartest/expect to_be_error","url":"startest/expect.html#to_be_error"},{"doc":"startest/expect","title":"to_be_false","content":"pub fn to_be_false(actual: Bool) -&gt; Nil\n Asserts that the given value is `False`.\nSynonyms:\nstartest/expect.to_be_false\nstartest/expect to_be_false","url":"startest/expect.html#to_be_false"},{"doc":"startest/expect","title":"to_be_none","content":"pub fn to_be_none(actual: Option(a)) -&gt; Nil\n Asserts that the given value is `None`.\nSynonyms:\nstartest/expect.to_be_none\nstartest/expect to_be_none","url":"startest/expect.html#to_be_none"},{"doc":"startest/expect","title":"to_be_ok","content":"pub fn to_be_ok(actual: Result(a, b)) -&gt; a\n Asserts that the given value is `Ok(_)`.\nSynonyms:\nstartest/expect.to_be_ok\nstartest/expect to_be_ok","url":"startest/expect.html#to_be_ok"},{"doc":"startest/expect","title":"to_be_some","content":"pub fn to_be_some(actual: Option(a)) -&gt; a\n Asserts that the given value is `Some(_)`.\nSynonyms:\nstartest/expect.to_be_some\nstartest/expect to_be_some","url":"startest/expect.html#to_be_some"},{"doc":"startest/expect","title":"to_be_true","content":"pub fn to_be_true(actual: Bool) -&gt; Nil\n Asserts that the given value is `True`.\nSynonyms:\nstartest/expect.to_be_true\nstartest/expect to_be_true","url":"startest/expect.html#to_be_true"},{"doc":"startest/expect","title":"to_equal","content":"pub fn to_equal(actual: a, expected expected: a) -&gt; Nil\n Asserts that the given value is equal to the expected value.\nSynonyms:\nstartest/expect.to_equal\nstartest/expect to_equal","url":"startest/expect.html#to_equal"},{"doc":"startest/expect","title":"to_not_equal","content":"pub fn to_not_equal(actual: a, expected expected: a) -&gt; Nil\n Asserts that the given value is not equal to the expected value.\nSynonyms:\nstartest/expect.to_not_equal\nstartest/expect to_not_equal","url":"startest/expect.html#to_not_equal"},{"doc":"startest/expect","title":"to_not_throw","content":"pub fn to_not_throw(f: fn() -&gt; a) -&gt; a\n Asserts that the given function does not throw an error.\nSynonyms:\nstartest/expect.to_not_throw\nstartest/expect to_not_throw","url":"startest/expect.html#to_not_throw"},{"doc":"startest/expect","title":"to_throw","content":"pub fn to_throw(f: fn() -&gt; a) -&gt; Nil\n Asserts that the given function throws an error.\nSynonyms:\nstartest/expect.to_throw\nstartest/expect to_throw","url":"startest/expect.html#to_throw"},{"doc":"startest/expect","title":"startest/expect","content":" Assertions to be used in tests.","url":"startest/expect.html"},{"doc":"startest/reporters/default","title":"new","content":"pub fn new() -&gt; Reporter\n\nSynonyms:\nstartest/reporters/default.new\nstartest/reporters/default new","url":"startest/reporters/default.html#new"},{"doc":"startest/reporters/default","title":"startest/reporters/default","content":"","url":"startest/reporters/default.html"}]);